{-# LANGUAGE ImplicitParams #-}
module Definitive (
  module Definitive.Base,
  module Data.Containers,
  module Data.Containers.Sequence,
  trace,trace2,mtrace,debug,

  cli
  ) where

import Definitive.Base 
import System.Environment (getArgs)
import Data.Containers
import Data.Containers.Sequence

trace :: String -> a -> a
trace s x = (putStrLn s^.thunk)`seq`x
trace2 :: String -> String -> a -> a
trace2 b a x = trace b (x`seq`trace a x)
mtrace :: Unit f => String -> f ()
mtrace str = trace str (pure ())
debug :: Show a => a -> a
debug x = trace (show x) x

cli :: String -> (( ?cliargs :: [String], ?progName :: String ) => IO a) -> IO a
cli name main = getArgs >>= \a -> let ?progName = name ; ?cliargs = a in main
